#ifndef _COMMANDSWIDGET_H
#define _COMMANDSWIDGET_H

#include <qhbox.h>
#include <qstring.h>

class CommandsWidget : public QHBox
{
	Q_OBJECT
	
	public:
		CommandsWidget ( QWidget * parent = NULL, const char * name = NULL, WFlags flags = 0 );

	signals:
		void Quit ( );
		void Go ( );
		void Help ( );
		
	public slots:
		void NewOutputDir ( const QString & );
		void FileSelectionChanged ( unsigned int );
		
	private:
		QWidget * m_help, * m_quit, * m_go;
		unsigned int m_filesSelected;
		bool m_outputDirValid;

		bool IsDirectory ( const QString & dir );
		void UpdateGoButton ( );
};

#endif
