#include "helpwidget.h"
#include "mimefactory.h"

HelpWidget::HelpWidget ( QWidget * parent, const char * name, WFlags flags )
	: QVBox ( parent, name, flags )
	, m_display ( NULL )
	, m_buttons ( NULL )
{
	setMargin ( 5 );
	setSpacing ( 5 );

	// Setup the text window
	m_display = new QTextBrowser ( this );

	QStringList pageNames ( TheMimeFactory ( ).GetPageNames ( ) );
	for ( QStringList::const_iterator pageName ( pageNames.constBegin ( ) ); pageName != pageNames.constEnd ( ); ++pageName )
		m_display->mimeSourceFactory ( )->setText ( *pageName, TheMimeFactory ( ).GetText ( *pageName ) );

	QStringList imageNames ( TheMimeFactory ( ).GetImageNames ( ) );
	for ( QStringList::const_iterator imageName ( imageNames.constBegin ( ) ); imageName != imageNames.constEnd ( ); ++imageName )
		m_display->mimeSourceFactory ( )->setImage ( *imageName, TheMimeFactory ( ).GetImage ( *imageName ) );
	
	m_display->setSource ( "index" );
	
	// Setup the buttons 
	m_buttons = new HelpButtonsWidget ( this );

	connect ( m_buttons, SIGNAL ( Home ( ) ), m_display, SLOT ( home ( ) ) );
	connect ( m_buttons, SIGNAL ( Back ( ) ), m_display, SLOT ( backward ( ) ) );
	connect ( m_buttons, SIGNAL ( Forward ( ) ), m_display, SLOT ( forward ( ) ) );

	connect ( m_buttons, SIGNAL ( Quit ( ) ), this, SIGNAL ( Quit ( ) ) );
}
