#ifndef _MAINWINDOW_H
#define _MAINWINDOW_H

#include <qapplication.h>
#include <qwidget.h>

class MainWindowWidget : public QWidget
{
	Q_OBJECT
	
	public:
		MainWindowWidget ( QApplication & parent, const char * name = NULL, WFlags flags = 0 );

	signals:
		void Quit ( );
		void StartProcessing ( );

	public slots:
		void QuitCommand ( );
		void GoCommand ( );
		void HelpCommand ( );
		void HelpClosed ( );
		void ErrorClosed ( );

	private:
		QApplication & m_parent;
		size_t m_width, m_height;
		QWidget * m_files, * m_options, * m_output, * m_commands, * m_help, * m_error;

		QString GenerateNewFilename ( const QString & filename, const QString & dir, const QString & prefix, const QString & suffix ) const;
		QImage ResizeImage ( const QImage & image, const QSize & size, bool smooth, bool ratio ) const;
		QSize CalculateNewSize ( const QSize & currentSize, const QSize & desiredSize,  bool keepWidth, bool smart ) const;
		bool isJPEG ( const QString & format ) const;
};


#endif
