#ifndef _MIMEFACTORY_H
#define _MIMEFACTORY_H

#include <qstring.h>
#include <qdom.h>
#include <qdict.h>
#include <qstringlist.h>
#include <qimage.h>

class MimeFactory
{
	public:
		~MimeFactory ( );

		bool IsValid ( ) const;
		QStringList GetPageNames ( ) const;
		QStringList GetImageNames ( ) const;
		QString GetText ( const QString & name ) const;
		QImage GetImage ( const QString & name ) const;

		friend MimeFactory & TheMimeFactory ( const QString & sourcefile );

	private:
		bool m_valid;
		QDomDocument m_document;
		
		MimeFactory ( const QString & sourcefile );

		bool LoadFile ( QDomDocument & document, const QString & sourcefile ) const;
		bool ParseFile ( const QString & sourcefile );
		QString NodeToString ( QDomNode & node ) const;
		void ProcessString ( QString & string ) const;
		QDomElement GetElement ( const QString & type, const QString & name ) const;
		QStringList GetNames ( const QString & type ) const;
};

MimeFactory & TheMimeFactory ( const QString & sourcefile = "");

#endif
