#include "namingwidget.h"
#include <qlineedit.h>
#include <qlabel.h>
#include <qlayout.h>

NamingWidget::NamingWidget ( QWidget * parent, const char * name, WFlags flags )
	: QWidget ( parent, name, flags )
	, m_prefix ( NULL )
	, m_suffix ( NULL )
{
	// Create layout
	QHBoxLayout * layout ( new QHBoxLayout ( this ) );
	layout->setMargin ( 0 );
	layout->setSpacing ( 5 );

	// Create prefix and suffix inputs
	m_prefix = new QLineEdit ( "", this );
	m_suffix = new QLineEdit ( "", this );

	layout->addWidget ( new QLabel ( "Output files prefix/suffix : ", this ) );
	layout->addWidget ( m_prefix );
	layout->addWidget ( new QLabel ( "[filename]", this ) );
	layout->addWidget ( m_suffix );
	layout->addWidget ( new QLabel ( ".[ext]", this ) );
}


QString NamingWidget::GetPrefix ( ) const
{
	return static_cast < QLineEdit * > ( m_prefix )->text ( );
}


QString NamingWidget::GetSuffix ( ) const
{
	return static_cast < QLineEdit * > ( m_suffix )->text ( );
}
