#include "outputoptionswidget.h"
#include "outputwidget.h"
#include "namingwidget.h"

OutputOptionsWidget::OutputOptionsWidget ( QWidget * parent, const char * name, WFlags flags )
	: QVBox ( parent, name, flags )
	, m_output ( NULL )
	, m_naming ( NULL )
{
	setMargin ( 5 );
	setSpacing ( 5 );
	setFrameShape ( QFrame::GroupBoxPanel );
	setFrameShadow ( QFrame::Sunken );

	m_output = new OutputWidget ( this );
	m_naming = new NamingWidget ( this );

	connect ( m_output, SIGNAL ( DirTextChanged ( const QString & ) ), this, SIGNAL ( DirectoryChanged ( const QString & ) ) );
}


QString OutputOptionsWidget::GetOutputDirectory ( ) const
{
	return static_cast < OutputWidget * > ( m_output )->GetDirectory ( );
}


QString OutputOptionsWidget::GetOutputPrefix ( ) const
{
	return static_cast < NamingWidget * > ( m_naming )->GetPrefix ( );
}


QString OutputOptionsWidget::GetOutputSuffix ( ) const
{
	return static_cast < NamingWidget * > ( m_naming )->GetSuffix ( );
}
