#include "outputqualitywidget.h"
#include "configfile.h"
#include <qlabel.h>
#include <qlayout.h>


OutputQualityWidget::OutputQualityWidget ( QWidget * parent, const char * name, WFlags flags )
	: QWidget ( parent, name, flags )
	, m_quality ( NULL )
	, m_qualityDisplay ( NULL )
{
	// Create the layout
	QHBoxLayout * layout ( new QHBoxLayout ( this ) );
	layout->setMargin ( 0 );
	layout->setSpacing ( 5 );
	layout->setAlignment ( Qt::AlignRight );
	
	// Create the slider
	m_quality = new QSlider ( 0, 100, 1, TheConfigFile ( ).NewImageJpegQuality ( ), Qt::Horizontal, this );

	// Create the value label
	m_qualityDisplay = new QLabel ( QString ( "%1\%" ).arg ( m_quality->maxValue ( ) ), this );
	QSize textSize ( m_qualityDisplay->fontMetrics ( ).size ( Qt::SingleLine, m_qualityDisplay->text ( ) ) );
	m_qualityDisplay->setMinimumSize ( textSize );

	// Fix the sliders maximum height
	m_quality->setMaximumHeight ( textSize.height ( ) + 2 );

	// Add the widgets to the layout
	layout->addWidget ( new QLabel ( "JPEG Quality : ", this ) );
	layout->addWidget ( m_quality );
	layout->addWidget ( m_qualityDisplay );

	// Plumb in the signals/slots
	connect ( m_quality, SIGNAL ( sliderMoved ( int ) ), this, SLOT ( QualityAdjusted ( int ) ) );

	// Set the default quality
	QualityAdjusted ( TheConfigFile ( ).NewImageJpegQuality ( ) );
}


void OutputQualityWidget::QualityAdjusted ( int value )
{
	m_qualityDisplay->setText ( QString ( "%1\%" ).arg ( value ) );
}


unsigned int OutputQualityWidget::Value ( ) const
{
	return m_quality->value ( );
}
