#include "processingoptionswidget.h"
#include "resizewidget.h"
#include "qualitylayoutwidget.h"

ProcessingOptionsWidget::ProcessingOptionsWidget ( QWidget * parent, const char * name, WFlags flags )
	: QVBox ( parent, name, flags )
	, m_resize ( NULL )
	, m_quality ( NULL )
{
	setMargin ( 5 );
	setSpacing ( 5 );
	setFrameShape ( QFrame::GroupBoxPanel );
	setFrameShadow ( QFrame::Sunken );

	m_resize = new ResizeWidget ( this );
	m_quality = new QualityLayoutWidget ( this );
}


bool ProcessingOptionsWidget::IsQualityOptionSet ( const QString & option ) const
{
	return static_cast < QualityLayoutWidget * > ( m_quality )->IsOptionSet ( option );
}


QSize ProcessingOptionsWidget::GetOutputSize ( ) const
{
	return QSize ( static_cast < ResizeWidget * > ( m_resize )->Width ( ),
			       static_cast < ResizeWidget * > ( m_resize )->Height ( ) );
}


bool ProcessingOptionsWidget::RatioIgnore ( ) const
{
	return static_cast < ResizeWidget * > ( m_resize )->RatioIgnore ( );
}


bool ProcessingOptionsWidget::RatioWidth ( ) const
{
	return static_cast < ResizeWidget * > ( m_resize )->RatioWidth ( );
}


bool ProcessingOptionsWidget::RatioHeight ( ) const
{
	return static_cast < ResizeWidget * > ( m_resize )->RatioHeight ( );
}


bool ProcessingOptionsWidget::RatioSmart ( ) const
{
	return static_cast < ResizeWidget * > ( m_resize )->RatioSmart ( );
}


unsigned int ProcessingOptionsWidget::GetJPEGQuality ( ) const
{
	return static_cast < QualityLayoutWidget * > ( m_quality )->JPEGQuality ( );
}
