#include "qualitylayoutwidget.h"
#include "scalequalitywidget.h"
#include "outputqualitywidget.h"
#include <qlayout.h>
		

QualityLayoutWidget::QualityLayoutWidget ( QWidget * parent, const char * name, WFlags flags )
	: QWidget ( parent, name, flags )
	, m_options ( NULL )
	, m_output ( NULL )
{
	QHBoxLayout * layout ( new QHBoxLayout ( this ) );
	layout->setMargin ( 0 );
	layout->setSpacing ( 0 );
	layout->setAlignment ( Qt::AlignJustify );
	
	m_options = new ScaleQualityWidget ( this );
	m_output = new OutputQualityWidget ( this );
	
	layout->addWidget ( m_options, Qt::AlignLeft );
	layout->addSpacing ( 32 );
	layout->addWidget ( m_output, Qt::AlignRight );
}


bool QualityLayoutWidget::IsOptionSet ( const QString & option ) const
{
	return static_cast < ScaleQualityWidget * > ( m_options )->IsOptionSet ( option );
}


unsigned int QualityLayoutWidget::JPEGQuality ( ) const
{
	return static_cast < OutputQualityWidget * > ( m_output )->Value ( );
}
