#include "uudecoder.h"
#include <qregexp.h>
#include <stdlib.h>


inline char DecodeSingleChar ( char character )
{
	return ( character - ' ' ) & 077;
}


QString GetLine ( QString & string )
{
	if ( string [ 0 ] == '\n' )
		exit ( 0 );
	int newLinePos ( string.find ( '\n' ) );
	if ( newLinePos == - 1 )
	{
		QString line ( string );
		string = "";
		return line;
	}
	else
	{
		QString line ( string.left ( newLinePos ) );
		string = string.right ( string.length ( ) - newLinePos );
		string.remove ( QRegExp ( "^[ \t\r\n]+" ) );
		return line;
	}
}


QByteArray UUDecoder::Decode ( const QString & inputRef )
{
	QString input ( inputRef );
	QByteArray output;
	size_t outputIndex ( 0 );

	while ( ! input.isEmpty ( ) )
	{
		QString line ( GetLine ( input ) );
		const char * ptr ( line.ascii ( ) );

		int number ( DecodeSingleChar ( *ptr ) );
		if ( number <= 0 )
			break;

		output.resize ( output.size ( ) + number );
		for ( ++ptr; number > 0; ptr += 4, number -= 3 )
		{
			if ( number >= 3 )
			{	
				output [ outputIndex++ ] = DecodeSingleChar ( ptr [0] ) << 2 | DecodeSingleChar ( ptr [1] ) >> 4;
				output [ outputIndex++ ] = DecodeSingleChar ( ptr [1] ) << 4 | DecodeSingleChar ( ptr [2] ) >> 2;
				output [ outputIndex++ ] = DecodeSingleChar ( ptr [2] ) << 6 | DecodeSingleChar ( ptr [3] );
			}
			else
			{
				if ( number >= 1 )
					output [ outputIndex++ ] = DecodeSingleChar ( ptr [0] ) << 2 | DecodeSingleChar ( ptr [1] ) >> 4;
				if ( number >= 2 )
					output [ outputIndex++ ] = DecodeSingleChar ( ptr [1] ) << 4 | DecodeSingleChar ( ptr [2] ) >> 2;
			}
		}
	}

	output.resize ( outputIndex );
	return output;
}
